de.katho.kBorrow.gui

## Class UserPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - de.katho.kBorrow.gui.UserPanel

All Implemented Interfaces:
  java.awt.event.ActionListener, java.awt.event.KeyListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible

    public class UserPanel
    extends javax.swing.JPanel
    implements java.awt.event.ActionListener, java.awt.event.KeyListener

Erzeugt das UserPanel und reicht Benutzerinteraktionen an den entsprechenden Controller weiter.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JPanel

`javax.swing.JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class javax.swing.JComponent

`javax.swing.JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

Fields
`private javax.swing.JButton` `btnUserCancel` Button: Abbrechen
`private javax.swing.JButton` `btnUserSave` Button: Speichern
`private KUserModel` `kUserModel` Referenz auf das KUserModel
`private javax.swing.JLabel` `lblUserStatus` Label: Statusmeldung
`private static long` `serialVersionUID` Serial Version UID
`private javax.swing.JTextField` `textFieldUserName` Textfeld: Benutzer Vorname
`private javax.swing.JTextField` `textFieldUserSurname` Textfeld: Benutzer Nachname
`private UserController` `userController` Referenz auf den UserController
`private int` `userEditId` ID des Benutzers, der bearbeitet werden soll
`private boolean` `userModeEdit` True, wenn gerade ein Benutzer bearbeitet werden soll, andernfalls false.

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`UserPanel(DbConnector dbCon, java.util.HashMap<java.lang.String,KDataModel> models)` Erzeugt das UserPanel

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `actionPerformed(java.awt.event.ActionEvent e)` ActionListener für gedrückte Buttons.
`void` `keyPressed(java.awt.event.KeyEvent pKeyPress)` KeyListener für den Druck einer Taste Ruft `saveButtonPressed()` auf, wenn die gedrückte Taste die Entertaste war.
`void` `keyReleased(java.awt.event.KeyEvent arg0)` KeyListener für das Loslassen einer Taste.
`void` `keyTyped(java.awt.event.KeyEvent arg0)` KeyListener für das Tippen (Drücken und Loslassen) einer Taste.
`void` `resetModeEditUser()` Setzt das Formular zurück.
`private void` `saveButtonPressed()` Führt die Aktionen aus, die geschehen, wenn der Speichern-Button gedrückt wird.
`void` `setModeEditUser(int pId)` Setzt Werte im Formular, wenn ein Benutzer bearbeitet werden soll.
`void` `setStatusLabel(java.lang.String pText)` Setzt den als Parameter übergebenen Text in das Status-Label.

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serial Version UID

See Also:
  Constant Field Values

#### lblUserStatus

    private javax.swing.JLabel lblUserStatus

Label: Statusmeldung

#### textFieldUserName

    private javax.swing.JTextField textFieldUserName

Textfeld: Benutzer Vorname

#### textFieldUserSurname

    private javax.swing.JTextField textFieldUserSurname

Textfeld: Benutzer Nachname

#### btnUserSave

    private javax.swing.JButton btnUserSave

Button: Speichern

#### btnUserCancel

    private javax.swing.JButton btnUserCancel

Button: Abbrechen

#### userModeEdit

    private boolean userModeEdit

True, wenn gerade ein Benutzer bearbeitet werden soll, andernfalls false.

#### userEditId

    private int userEditId

ID des Benutzers, der bearbeitet werden soll

#### kUserModel

    private KUserModel kUserModel

Referenz auf das KUserModel

#### userController

    private UserController userController

Referenz auf den UserController

### Constructor Detail

#### UserPanel

    public UserPanel(DbConnector dbCon,
                     java.util.HashMap<java.lang.String,KDataModel> models)
              throws java.io.IOException

Erzeugt das UserPanel

Parameters:
  `dbCon` - Referenz auf die Datenbankverbindung.
  `models` - HashMaps mit KDataModels.
Throws:
  `java.io.IOException` - Wenn Fehler im `UserDeleteTableButton` oder `UserEditTableButton` auftreten.

### Method Detail

#### actionPerformed

    public void actionPerformed(java.awt.event.ActionEvent e)

ActionListener für gedrückte Buttons.

Ruft `saveButtonPressed()` auf, wenn der Speichern-Button und `resetModeEditUser()`, wenn der Abbrechen-Button gedrückt wurde.

Specified by:
  `actionPerformed` in interface `java.awt.event.ActionListener`
Parameters:
  `e` - ActionEvent, das den Listener aufgerufen hat.

#### resetModeEditUser

    public void resetModeEditUser()

Setzt das Formular zurück.

#### setModeEditUser

    public void setModeEditUser(int pId)

Setzt Werte im Formular, wenn ein Benutzer bearbeitet werden soll.

Parameters:
  `pId` - ID des Benutzers, der bearbeitet werden soll.

#### saveButtonPressed

    private void saveButtonPressed()

Führt die Aktionen aus, die geschehen, wenn der Speichern-Button gedrückt wird.

Übergibt Inhalt des Formulars an den UserController und gibt je nach Rückgabecode eine andere Statusmeldung aus.

#### setStatusLabel

    public void setStatusLabel(java.lang.String pText)

Setzt den als Parameter übergebenen Text in das Status-Label.

Parameters:
  `pText` - Zu setzender Text.

#### keyPressed

    public void keyPressed(java.awt.event.KeyEvent pKeyPress)

KeyListener für den Druck einer Taste

Ruft `saveButtonPressed()` auf, wenn die gedrückte Taste die Entertaste war.

Specified by:
  `keyPressed` in interface `java.awt.event.KeyListener`
Parameters:
  `pKeyPress` - KeyEvent, von dem das Event erzeugt wurde.

#### keyReleased

    public void keyReleased(java.awt.event.KeyEvent arg0)

KeyListener für das Loslassen einer Taste.

Nicht implementiert

Specified by:
  `keyReleased` in interface `java.awt.event.KeyListener`
Parameters:
  `arg0` - KeyEvent, von dem das Event erzeugt wird.

#### keyTyped

    public void keyTyped(java.awt.event.KeyEvent arg0)

KeyListener für das Tippen (Drücken und Loslassen) einer Taste.

Nicht implementiert

Specified by:
  `keyTyped` in interface `java.awt.event.KeyListener`
Parameters:
  `arg0` - KeyEvent, von dem das Event erzeugt wird.